import greenfoot.*; // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Font;
import java.awt.Color;

public class Counter extends Actor
{
    private int value = 0;
    private String text = "";
    private int stringLength;
    boolean defaultLocation;

    public Counter(int x)
    {
        this("",x,0);
        refresh();
    }

    public Counter(String prefix, int x, int size)
    {
        defaultLocation = true;

        text = prefix;
        value = x;
        stringLength = (text.length() + 4) * 4;

        setImage(new GreenfootImage(stringLength, 18));
        GreenfootImage image = getImage();
        Font font = image.getFont();

        image.setFont(font.deriveFont(size + 14.0F));
        image.setColor(Color.white);
    }

    public int getValue()
    {
        return value;
    }

    public void setValue(int x)
    {
        value = x;
        refresh();
    }

    public void show(String text)
    {
        this.text = text;
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text, 0, 15);
    }

    public void setSize(int size)
    {
        GreenfootImage image = getImage();
        Font font = image.getFont();
        image.clear();
        image.drawString(text, 1, 15);
        image.setFont(font.deriveFont(size + 0.0F));
        image.setColor(Color.white);
    }

    public void increaseValue()
    {
        value++;
        refresh();
    }

    public void decreaseValue()
    {
        value--;
        refresh();
    }

    public void refresh()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 0, 15);
        // --- --- --- Check counter's position and shift it whenever the value is less than 10 or higher than 9
        try
        {
            if( value < 10 && defaultLocation)
            {
                setLocation(getX()+4,getY());
                defaultLocation = false;
            }
            else
            if( value > 9 && !defaultLocation)
            {
                setLocation(getX()-4,getY());
                defaultLocation = true;
            }
        }catch(Exception e){}
    }
}