import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;

/**
 * Write a description of class Picture here.
 * 
 * @author Segara 
 * @version 1.00
 */
public class Picture extends Actor
{
    private boolean clickable;
    private boolean selfDestructive;

    public void act()
    {
        if(clickable && Greenfoot.mouseClicked(this))
        {
            ((Application) getWorld()).helpWindowExist = false;
            ((Application) getWorld()).infoWindowExist = false;
            ((Application) getWorld()).resetWindowExist = false;
            if(selfDestructive)
            {
                Greenfoot.playSound("ButtonClick.mp3");
                getWorld().removeObject(this);
            }
        }
        if(!selfDestructive)mouse();
    }

    public Picture(boolean setUp, boolean temporare)
    {
        this.clickable = setUp;
        this.selfDestructive = temporare;
    }
    
    private int counter = 0;
    private int frequency = 11; // the lower this number the more effects
    private void mouse()
    {
        counter++;
        if(Greenfoot.mouseMoved( ((Application) getWorld()).background ) && counter % frequency == 0 )
        {
            Star star = new Star();
            ((Application) getWorld()).addObject( 
            star, 
            Greenfoot.getMouseInfo().getX()+((new Random()).nextInt(20)-10), 
            Greenfoot.getMouseInfo().getY()+((new Random()).nextInt(20)-10)
            );
            star.setImage("Star-"+((new Random()).nextInt(8)+1)+".png");
            star.getImage().scale( ((new Random()).nextInt(4)+1),((new Random()).nextInt(4)+1));
        }
        if(counter > 100)counter = 0;
    }
}