import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.Random;

/**
 * Write a description of class Star here.
 * 
 * @author Segara 
 * @version 1.00
 */
public class Star extends Actor
{
    private int counter = 0;
    private int transparencySpeed;
    private int scalingSpeed;
    private int moveSpeed;

    public void act()
    {
        counter++; 
        action();
        if(counter > 2)counter = 0; // 75 was 2000 at speed of 100
    }

    public Star()
    {
        moveSpeed = 2; // was 2000
        transparencySpeed = 1; // was 250 at speed of 100
    }

    private void action()
    {
        if(counter % transparencySpeed == 0)addTransparency(1);

        if(counter % moveSpeed == 0)move();

        checkEffect();
        checkHealth();
    }

    private void increaseSize(int meaning){
        {
            getImage().scale(getImage().getWidth()+meaning,getImage().getHeight()+meaning);
        }
    }

    private void addTransparency(int meaning){getImage().setTransparency(getImage().getTransparency() - meaning);}

    private void checkHealth()
    {
        if(getImage().getTransparency() <= 30)
        { 
            ((Application) getWorld()).removeObject(this);
        }
    }

    private void move()
    {
        int r = 90;
        switch((new Random()).nextInt(12)+1)
        {
            case 1://this.setLocation(this.getX(),this.getY()-1); // up
            this.setLocation(this.getX(),this.getY()+2);// down
            break;

            case 2:this.setLocation(this.getX()+1,this.getY());// right
            break;

            case 3:this.setLocation(this.getX(),this.getY()+2);// down
            break;

            case 4:this.setLocation(this.getX()-1,this.getY());// left
            break;

            case 8:
            this.setLocation(this.getX(),this.getY()+2);// down
            this.setRotation(this.getRotation()-r);
            break;

            case 9:
            this.setLocation(this.getX()+1,this.getY());// right
            this.setRotation(this.getRotation()-r);
            break;

            case 10:
            this.setLocation(this.getX(),this.getY()+2);// down
            this.setRotation(this.getRotation()-r);
            break;

            case 11:
            this.setLocation(this.getX()-1,this.getY());// left
            this.setRotation(this.getRotation()-r);
            break;

            case 12:
            //this.setLocation(this.getX(),this.getY()-1); // up
            this.setLocation(this.getX(),this.getY()+2);// down
            this.setRotation(this.getRotation()+r);
            break;

            case 5:
            this.setLocation(this.getX()+1,this.getY());// right
            this.setRotation(this.getRotation()+r);
            break;

            case 6:
            this.setLocation(this.getX(),this.getY()+2);// down
            this.setRotation(this.getRotation()+r);
            break;

            case 7:
            this.setLocation(this.getX()-1,this.getY());// left
            this.setRotation(this.getRotation()+r);
            break;
        }
    }

    private void checkEffect()
    {
        if(this.getX() == 0 || this.getX() >= 1000 || this.getY() == 0 || this.getY() == 300)
        {
            ((Application) getWorld()).removeObject(this);
        }
    }
}